package nouritsu.types;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.vavr.collection.HashSet;
import io.vavr.collection.Seq;

/**
 * A sorted shopping list for a store.
 * Rest contains the items that can’t be purchased at the selected store.
 */
public record ListWithRest(
  @JsonProperty("items") Seq<ShoppingItem> items,
  @JsonProperty("rest") HashSet<ShoppingItem> rest
) {}
